<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet version = '1.0'
	xmlns:xsl='http://www.w3.org/1999/XSL/Transform'>
<xsl:output method="html" encoding="utf-8"
	doctype-public="-//W3C//DTD HTML 4.01 Transitional//EN"/>

<!-- transform some xml file to a visually more apprehensible
representation of nested blocks; written for the openbox
configuration file format as a documentation tool.
Peter Chiocchetti, Mon Jun 30 00:32:54 CEST 2003 -->


<xsl:template match="//*">
	<xsl:choose>
		<xsl:when test="normalize-space(text())=''">
			<dt class="el"><xsl:value-of select="name()"/>:
				<dd>
					<!-- attributes -->
					<xsl:if test="not(count(@*)=0)">
						<dl>
							<xsl:for-each select="@*">
									<dt class="at"><xsl:value-of select="name()"/>:</dt>
									<dd><xsl:value-of select="."/></dd>
							</xsl:for-each>
						</dl>
					</xsl:if>
					<!-- attributes end -->
					<dl>
						<xsl:apply-templates select="node()"/>
					</dl>
				</dd>
			</dt>
		</xsl:when>
		<xsl:otherwise>
			<dt class="el"><xsl:value-of select="name()"/>:</dt>
			<dd><xsl:apply-templates select="node()"/></dd>
			<!-- attributes -->
			<xsl:for-each select="@*">
				<dt class="at"><xsl:value-of select="name()"/>:</dt>
				<dd><xsl:value-of select="."/></dd>
			</xsl:for-each>
			<!-- attributes end -->
		</xsl:otherwise>
	</xsl:choose>
</xsl:template>

<xsl:template match="/*">
	<html>
		<head>
			<title>Openbox Config</title>
			<style type="text/css">
				dl { background:#eaeaea;border:solid;border-width:1px;border-color:#000000;padding:3px;margin:3px; }
				dt { font-style:italic; }
				dd { margin-left:1em; }
				.el { color:#ff0000; }
				.at { color:#0000ff; }
			</style>
		</head>
		<body>
			<h1>Openbox Configuration variables</h1>

			<p>This document lists the elements
			and attributes of an openbox
			configuration file. Element names are
			red, attribute names are blue;
			values are black; the nesting shown
			corresponds to the place in the
			xml-tree of the file. This document is
			mostly useful for people who cant wait
			for obconf, and to have a document on
			all available options.</p>

			<dl>
			<xsl:apply-templates select="node()" />
			</dl>
		</body>
	</html>
</xsl:template>

</xsl:stylesheet>
